--- a/board/verik/venus_2/board.c	2018-06-23 17:44:28.704759450 +0700
+++ b/board/verik/venus_2/board.c	2018-06-23 17:54:57.392748192 +0700
@@ -31,9 +31,9 @@
 #include <power/tps65910.h>
 #include <environment.h>
 #include <watchdog.h>
-#include <environment.h>
 #include <leds.h>
 #include <u-boot/crc.h>
+#include <ext4fs.h>
 #include "board.h"
 
 DECLARE_GLOBAL_DATA_PTR;
@@ -127,7 +127,9 @@
 			{	
 				printf("write eeprom section :%d failure.\n", i);
 				return 0;
-			}	
+			}
+
+			mdelay(100);
 		}
 
 		if(remainder)
@@ -161,7 +163,7 @@
 
 	/* read the eeprom using i2c */
 	if (i2c_read(CONFIG_SYS_I2C_EEPROM_ADDR, CONFIG_SYS_EEPROM_PRODUCT_INFO, 2, (uchar *)header,
-		     sizeof(struct am335x_baseboard_id))) {
+			 sizeof(struct am335x_baseboard_id))) {
 		puts("Could not read the EEPROM; something fundamentally"
 			" wrong on the I2C bus.\n");
 		return 0;
@@ -180,6 +182,7 @@
 				/* Write header */
 				write_data_eeprom(CONFIG_SYS_EEPROM_PRODUCT_INFO, (uint8_t *)buffer_header, sizeof(buffer_header));
 
+				mdelay(1000);
 				/* Write data info */
 				write_data_eeprom(offset_data, (uint8_t *)buffer_data, sizeof(buffer_data));
 			}
@@ -191,7 +194,7 @@
 		mdelay(1000);
 
 		if (i2c_read(CONFIG_SYS_I2C_EEPROM_ADDR, CONFIG_SYS_EEPROM_PRODUCT_INFO, 2, (uchar *)header,
-		     sizeof(struct am335x_baseboard_id))) 
+			 sizeof(struct am335x_baseboard_id))) 
 		{
 			puts("Could not read the EEPROM; something fundamentally"
 				" wrong on the I2C bus.\n");
@@ -202,11 +205,11 @@
 	return 1;
 };
 
-static int read_data(unsigned int offset_content, struct zinno_product_info *proinfo, uint32_t check_sum)
+static int read_data(struct am335x_baseboard_id *header, struct zinno_product_info *proinfo)
 {
 	uint32_t val = 0;
 	unsigned int offset_data = 0;
-	offset_data = CONFIG_SYS_EEPROM_PRODUCT_INFO + offset_content;
+	offset_data = CONFIG_SYS_EEPROM_PRODUCT_INFO + header->offset_content;
 	
 	/* Check if baseboard eeprom is available */
 	if (i2c_probe(CONFIG_SYS_I2C_EEPROM_ADDR)) {
@@ -225,7 +228,7 @@
 	val = crc32(0, (unsigned char *)proinfo, sizeof(struct zinno_product_info));
 
 	/* Check Contents crc32 */
-	if(check_sum != val) 
+	if(header->crc32_content != val) 
 	{
 		printf("EEPROM Product data CRC32 wrong.\n");			
 		
@@ -234,6 +237,8 @@
 		{
 			if(!gpio_direction_output(100, 0))
 			{
+				write_data_eeprom(CONFIG_SYS_EEPROM_PRODUCT_INFO, (uint8_t *)buffer_header, sizeof(buffer_header));
+				mdelay(1000);
 				write_data_eeprom(offset_data, (uint8_t *)buffer_data, sizeof(buffer_data));
 			}
 
@@ -241,6 +246,13 @@
 		}
 		mdelay(1000);
 
+		if (i2c_read(CONFIG_SYS_I2C_EEPROM_ADDR, CONFIG_SYS_EEPROM_PRODUCT_INFO, 2, (uchar *)header,
+			 sizeof(struct am335x_baseboard_id))) 
+		{
+			puts("Could not read the EEPROM; something fundamentally"
+				" wrong on the I2C bus.\n");
+			return 0;
+		}
 		if (i2c_read(CONFIG_SYS_I2C_EEPROM_ADDR, offset_data, 2, (uchar *)proinfo, sizeof(struct zinno_product_info))) 
 		{
 			puts("Could not read the EEPROM; something fundamentally"
@@ -274,7 +286,7 @@
 	/* Check magic header*/
 	if(board_is_zinno(header)) 
 	{
-		if(read_data((unsigned int)header->offset_content, proinfo, header->crc32_content))
+		if(read_data(header, proinfo))
 		{
 			printf("Read Data EEPROM Success.\n");
 		}	
@@ -442,14 +454,14 @@
 		}
 
 		if (tps65217_reg_write(TPS65217_PROT_LEVEL_NONE,
-				       TPS65217_POWER_PATH,
-				       usb_cur_lim,
-				       TPS65217_USB_INPUT_CUR_LIMIT_MASK))
+					   TPS65217_POWER_PATH,
+					   usb_cur_lim,
+					   TPS65217_USB_INPUT_CUR_LIMIT_MASK))
 			puts("tps65217_reg_write failure\n");
 
 		/* Set DCDC3 (CORE) voltage to 1.125V */
 		if (tps65217_voltage_update(TPS65217_DEFDCDC3,
-					    TPS65217_DCDC_VOLT_SEL_1125MV)) {
+						TPS65217_DCDC_VOLT_SEL_1125MV)) {
 			puts("tps65217_voltage_update failure\n");
 			return;
 		}
@@ -469,15 +481,15 @@
 		 */
 
 		if (tps65217_reg_write(TPS65217_PROT_LEVEL_2,
-				       TPS65217_DEFLS1,
-				       TPS65217_LDO_VOLTAGE_OUT_1_8,
-				       TPS65217_LDO_MASK))
+					   TPS65217_DEFLS1,
+					   TPS65217_LDO_VOLTAGE_OUT_1_8,
+					   TPS65217_LDO_MASK))
 			puts("tps65217_reg_write failure\n");
 
 		if (tps65217_reg_write(TPS65217_PROT_LEVEL_2,
-				       TPS65217_DEFLS2,
-				       TPS65217_LDO_VOLTAGE_OUT_3_3,
-				       TPS65217_LDO_MASK))
+					   TPS65217_DEFLS2,
+					   TPS65217_LDO_VOLTAGE_OUT_3_3,
+					   TPS65217_LDO_MASK))
 			puts("tps65217_reg_write failure\n");
 	}
 	/* Set MPU Frequency to what we detected now that voltages are set */
@@ -602,6 +614,337 @@
 	{-1},
 };
 #endif
+#define FIRMWARE_FILE           "/lib/firmware/ti-connectivity/wl1271-nvs.bin" 
+#define WIRELESS_FILE           "/etc/config/wireless"
+#define SECURITY_CONFIG_FILE    "/etc/config/security"
+#define OVERLAY_PART            "1:5"
+#define DEFAULT_MAC             "00:00:00:00:00:00"
+
+static void delete_wireless_content(char *boot_part)
+{
+	if(!boot_part)
+	{
+		return;
+	}
+
+
+	block_dev_desc_t *fs_dev_desc;
+	disk_partition_t fs_partition;
+
+	int part = get_device_and_partition("mmc", boot_part, &fs_dev_desc,
+					&fs_partition, 1);
+
+	if(!part)
+	{
+		return;
+	}
+
+	if(ext4fs_probe(fs_dev_desc, &fs_partition)){
+		printf("\n** Unable to use %s %s for loading the env **\n",
+			   "mmc", boot_part);
+		return;
+	}
+
+	ext4_remove_file(WIRELESS_FILE);
+	ext4fs_close();
+}
+
+// this function should be remove in production
+static void temporary_gen_mac(char *boot_part, char *output)
+{
+	if(!boot_part)
+	{
+		return;
+	}
+
+	ALLOC_CACHE_ALIGN_BUFFER(char, buff, 255);
+
+	block_dev_desc_t *fs_dev_desc;
+	disk_partition_t fs_partition;
+
+	int part = get_device_and_partition("mmc", boot_part, &fs_dev_desc,
+					&fs_partition, 1);
+
+	if(!part)
+	{
+		return;
+	}
+
+	if(ext4fs_probe(fs_dev_desc, &fs_partition)){
+		printf("\n** Unable to use %s %s for loading the env **\n",
+			   "mmc", boot_part);
+		return;
+	}
+
+	int err;
+	loff_t off;
+	// loff_t write;
+	err = ext4_read_file(SECURITY_CONFIG_FILE, buff, 0, 255, &off);
+
+	if (err == -1) {
+		printf("\n** Unable to read \"%s\" from %s%s **\n",
+			SECURITY_CONFIG_FILE, "mmc", boot_part);
+		return;
+	}
+
+	ext4fs_close();
+
+	char last3bytes[8];
+	char *first_minute = NULL;
+	char *next_minute = NULL;
+	char *deviceid_pointer = strstr(buff, "deviceid");
+	if(deviceid_pointer)
+	{
+		first_minute = strchr(deviceid_pointer, '\'');// find '
+	}
+
+	if(first_minute)
+	{
+		next_minute = strchr(first_minute+1, '\'');// find '
+	}
+	
+	if(next_minute)
+	{
+		/*remove 2 '' and 8 first byte*/
+		size_t length = next_minute-first_minute -1 -8;
+		if(length > (sizeof(last3bytes)-1))
+		{
+			return;
+		}
+
+		strncpy(last3bytes, first_minute+1+8, length);
+		last3bytes[length] = '\0';
+
+		char byte1[3],byte2[3],byte3[3];
+		strncpy(byte3, last3bytes, 2);
+		byte3[2]='\0';
+
+		strncpy(byte2, last3bytes+2, 2);
+		byte2[2]='\0';
+
+		strncpy(byte1, last3bytes+4, 2);
+		byte1[2]='\0';
+
+		sprintf(output, "aa:bb:cc:%s:%s:%s", byte3, byte2, byte1);
+	}
+}
+
+static int detect_boot_part(void)
+{
+	int bootstate = getenv_ulong("bootstate", 10, 0);
+	int checkboot = getenv_ulong("checkboot", 10, 0);
+
+	printf("bootstate %d\n", bootstate);
+	printf("checkboot %d\n", checkboot);
+
+	switch(bootstate) {
+		case 0:
+			return 2;
+
+		case 1:
+			if(checkboot)
+				return 3;
+			else
+				return 2;
+
+		case 2:
+			return 3;
+
+		case 3:
+			if(checkboot)
+				return 2;
+			else
+				return 3;
+		
+		default:
+			return 2;
+	}
+}
+
+static void write_epprom_macaddress(char *macAddress)
+{
+	struct am335x_baseboard_id header;
+	struct zinno_product_info proinfo;
+
+	/* Check if baseboard eeprom is available */
+	if (i2c_probe(CONFIG_SYS_I2C_EEPROM_ADDR)) {
+		puts("Could not probe the EEPROM; something fundamentally "
+			"wrong on the I2C bus.\n");
+		return;
+	}
+
+	/* read the eeprom using i2c */
+	if (i2c_read(CONFIG_SYS_I2C_EEPROM_ADDR, CONFIG_SYS_EEPROM_PRODUCT_INFO, 2, (uchar *)&header,
+			 sizeof(struct am335x_baseboard_id))
+		) 
+	{
+		puts("Could not read the EEPROM; something fundamentally"
+			" wrong on the I2C bus.\n");
+		return;
+	}
+
+	if (i2c_read(CONFIG_SYS_I2C_EEPROM_ADDR, CONFIG_SYS_EEPROM_PRODUCT_INFO+ header.offset_content, 2, (uchar *)&proinfo, 
+				sizeof(struct zinno_product_info))
+		)
+	{
+		puts("Could not read the EEPROM; something fundamentally"
+			" wrong on the I2C bus.\n");
+		return;
+	}
+
+	printf("current wifi  %s\n", proinfo.wifi_mac_address);
+	printf("crc current wifi  %02X\n", proinfo.wifi_mac_address[32]);
+
+	memcpy(proinfo.wifi_mac_address, macAddress, HDR_NAME_SIZE_32);
+	proinfo.wifi_mac_address[HDR_NAME_SIZE_32]=crc8((unsigned char *)proinfo.wifi_mac_address, HDR_NAME_SIZE_32);
+
+	printf("new wifi  %s\n", (char*)proinfo.wifi_mac_address);
+	printf("crc wifi %02X\n", proinfo.wifi_mac_address[32]);
+
+	header.crc32_content = crc32(0, (unsigned char *)&proinfo, sizeof(struct zinno_product_info));
+	header.hdr_crc8 = crc8((unsigned char *)&header, sizeof(struct am335x_baseboard_id) - 1);
+
+	printf("new crc32_content  %X\n", header.crc32_content);
+	printf("new hdr_crc8  %02X\n", header.hdr_crc8);
+
+
+	uint8_t *test = (uint8_t*)&proinfo;
+	int i;
+	for(i = 0; i < sizeof(struct zinno_product_info); i++)
+	{
+		printf("%02X ", test[i]);
+		if(i > 0 && ((i%16)==0))
+		{
+			printf("\n");
+		}
+	}
+
+	uint8_t *test1 = (uint8_t*)&header;
+	for(i = 0; i < sizeof(struct am335x_baseboard_id); i++)
+	{
+		printf("%02X ", test1[i]);
+		if(i > 0 && ((i%16)==0))
+		{
+			printf("\n");
+		}
+	}
+
+	if(!gpio_request(100, "Write_protect"))
+	{
+		if(!gpio_direction_output(100, 0))
+		{
+			/* Write header */
+			write_data_eeprom(CONFIG_SYS_EEPROM_PRODUCT_INFO, 
+							(uint8_t *)&header, sizeof(struct am335x_baseboard_id));
+
+			mdelay(1000);
+
+			/* Write data info */
+			write_data_eeprom(CONFIG_SYS_EEPROM_PRODUCT_INFO + DATA_CONTENT_OFFSET, 
+							(uint8_t *)&proinfo, sizeof(struct zinno_product_info));
+		}
+		gpio_free(100);
+	}
+}
+
+static void change_wifi_firmware_info(char *wifi_mac_address)
+{
+	if(!wifi_mac_address)
+	{
+		return;
+	}
+
+	ALLOC_CACHE_ALIGN_BUFFER(char, buff, 12);
+	ALLOC_CACHE_ALIGN_BUFFER(char, boot_part, 4);
+	ALLOC_CACHE_ALIGN_BUFFER(char, current_mac, 32);
+
+	snprintf(boot_part, 4, "1:%d", detect_boot_part());
+
+	printf("boot_part = %s\n", boot_part);
+
+	block_dev_desc_t *fs_dev_desc;
+	disk_partition_t fs_partition;
+
+	int part = get_device_and_partition("mmc", boot_part, &fs_dev_desc,
+					&fs_partition, 1);
+
+	if(!part)
+	{
+		return;
+	}
+
+	// if(!fs_dev_desc);
+	//     return;
+
+	if(ext4fs_probe(fs_dev_desc, &fs_partition)){
+		printf("\n** Unable to use %s %s for loading the env **\n",
+			   "mmc", boot_part);
+		return;
+	}
+	
+	int err;
+	loff_t off;
+	loff_t write;
+	err = ext4_read_file(FIRMWARE_FILE, buff, 0, 12, &off);
+
+	if (err == -1) {
+		printf("\n** Unable to read \"%s\" from %s%s **\n",
+			FIRMWARE_FILE, "mmc", boot_part);
+		return;
+	}
+
+	ext4fs_close();
+
+	snprintf(current_mac, 32, "%02x:%02x:%02x:%02x:%02x:%02x",
+			buff[11], buff[10], buff[6], buff[5], buff[4],
+			buff[3]);
+
+	printf("current_mac %s\n", current_mac);
+	printf("wifi_mac_address %s\n", wifi_mac_address);
+
+	if(!strcmp(wifi_mac_address, DEFAULT_MAC))
+	{
+		if(!strcmp(current_mac, DEFAULT_MAC))
+		{
+			temporary_gen_mac(OVERLAY_PART, wifi_mac_address);
+			write_epprom_macaddress(wifi_mac_address);
+			ext4fs_probe(fs_dev_desc, &fs_partition);
+		}
+		else
+		{
+			write_epprom_macaddress(current_mac);
+			return;
+		}
+	}
+
+	if(!strcmp(current_mac, wifi_mac_address))
+	{
+		return;
+	}
+
+	printf("update wifi mac from: %s to %s\n",
+			current_mac, wifi_mac_address);
+	ALLOC_CACHE_ALIGN_BUFFER(int, in_mac, 6);
+
+	err = sscanf(wifi_mac_address, "%2x:%2x:%2x:%2x:%2x:%2x",
+		&in_mac[0], &in_mac[1], &in_mac[2],
+		&in_mac[3], &in_mac[4], &in_mac[5]);
+	if (err != 6) {
+		fprintf(stderr, "MAC address is not valid: %s\n", wifi_mac_address);
+		return;
+	}
+
+	buff[11] = (unsigned char)in_mac[0];
+	buff[10] = (unsigned char)in_mac[1];
+	buff[6]  = (unsigned char)in_mac[2];
+	buff[5]  = (unsigned char)in_mac[3];
+	buff[4]  = (unsigned char)in_mac[4];
+	buff[3]  = (unsigned char)in_mac[5];
+
+	ext4_write_file(FIRMWARE_FILE, buff, 0, off, &write);
+	ext4fs_close();
+	delete_wireless_content(OVERLAY_PART);
+}
 
 int board_late_init(void)
 {
@@ -641,6 +984,9 @@
 	safe_string[HDR_NAME_SIZE_16] = 0;
 	setenv("board_rev", safe_string);
 
+	change_wifi_firmware_info(proinfo.wifi_mac_address);
+
+	
 	strncpy(safe_string, (char *)proinfo.wifi_mac_address, HDR_NAME_SIZE_32);
 	safe_string[HDR_NAME_SIZE_32] = 0;
 	setenv("wifi_mac_address", safe_string);
@@ -652,6 +998,7 @@
 	strncpy(safe_string, (char *)proinfo.serial_number, HDR_NAME_SIZE_16);
 	safe_string[HDR_NAME_SIZE_16] = 0;
 	setenv("serial_number", safe_string);	
+	saveenv();
 
 #endif
 
--- a/include/configs/venus_2.h	2018-06-23 17:44:53.644759003 +0700
+++ b/include/configs/venus_2.h	2018-06-23 17:41:59.924762114 +0700
@@ -486,5 +486,6 @@
 #define CONFIG_LEDS
 #define CONFIG_CMD_LEDS_LP5523
 #define CONFIG_LEDS_LP5523
+#define CONFIG_CMD_EXT4_WRITE
 
 #endif	/* ! __CONFIG_VENUS_2_H */
--- a/board/verik/venus/board.c	2018-06-24 12:57:14.000000000 +0700
+++ b/board/verik/venus/board.c	2018-06-24 14:33:37.551058878 +0700
@@ -31,8 +31,9 @@
 #include <power/tps65910.h>
 #include <environment.h>
 #include <watchdog.h>
-#include <environment.h>
 #include <leds.h>
+#include <u-boot/crc.h>
+#include <ext4fs.h>
 #include "board.h"
 
 DECLARE_GLOBAL_DATA_PTR;
@@ -123,6 +124,7 @@
 				printf("write eeprom section :%d failure.\n", i);
 				return 0;
 			}	
+			mdelay(100);
 		}
 
 		if(remainder)
@@ -175,6 +177,7 @@
 				/* Write header */
 				write_data_eeprom(CONFIG_SYS_EEPROM_PRODUCT_INFO, (uint8_t *)buffer_header, sizeof(buffer_header));
 
+				mdelay(1000);
 				/* Write data info */
 				write_data_eeprom(offset_data, (uint8_t *)buffer_data, sizeof(buffer_data));
 			}
@@ -197,11 +200,11 @@
 	return 1;
 };
 
-static int read_data(unsigned int offset_content, struct zinno_product_info *proinfo, uint32_t check_sum)
+static int read_data(struct am335x_baseboard_id *header, struct zinno_product_info *proinfo)
 {
 	uint32_t val = 0;
 	unsigned int offset_data = 0;
-	offset_data = CONFIG_SYS_EEPROM_PRODUCT_INFO + offset_content;
+	offset_data = CONFIG_SYS_EEPROM_PRODUCT_INFO + header->offset_content;
 	
 	/* Check if baseboard eeprom is available */
 	if (i2c_probe(CONFIG_SYS_I2C_EEPROM_ADDR)) {
@@ -220,7 +223,7 @@
 	val = crc32(0, (unsigned char *)proinfo, sizeof(struct zinno_product_info));
 
 	/* Check Contents crc32 */
-	if(check_sum != val) 
+	if(header->crc32_content != val) 
 	{
 		printf("EEPROM Product data CRC32 wrong.\n");			
 		
@@ -229,6 +232,8 @@
 		{
 			if(!gpio_direction_output(100, 0))
 			{
+				write_data_eeprom(CONFIG_SYS_EEPROM_PRODUCT_INFO, (uint8_t *)buffer_header, sizeof(buffer_header));
+				mdelay(1000);
 				write_data_eeprom(offset_data, (uint8_t *)buffer_data, sizeof(buffer_data));
 			}
 
@@ -236,6 +241,13 @@
 		}
 		mdelay(1000);
 
+		if (i2c_read(CONFIG_SYS_I2C_EEPROM_ADDR, CONFIG_SYS_EEPROM_PRODUCT_INFO, 2, (uchar *)header,
+			 sizeof(struct am335x_baseboard_id))) 
+		{
+			puts("Could not read the EEPROM; something fundamentally"
+				" wrong on the I2C bus.\n");
+			return 0;
+		}
 		if (i2c_read(CONFIG_SYS_I2C_EEPROM_ADDR, offset_data, 2, (uchar *)proinfo, sizeof(struct zinno_product_info))) 
 		{
 			puts("Could not read the EEPROM; something fundamentally"
@@ -269,7 +281,7 @@
 	/* Check magic header*/
 	if(board_is_zinno(header)) 
 	{
-		if(read_data((unsigned int)header->offset_content, proinfo, header->crc32_content))
+		if(read_data(header, proinfo))
 		{
 			printf("Read Data EEPROM Success.\n");
 		}	
@@ -545,6 +557,337 @@
 	{-1},
 };
 #endif
+#define FIRMWARE_FILE           "/lib/firmware/ti-connectivity/wl1271-nvs.bin" 
+#define WIRELESS_FILE           "/etc/config/wireless"
+#define SECURITY_CONFIG_FILE    "/etc/config/security"
+#define OVERLAY_PART            "1:5"
+#define DEFAULT_MAC             "00:00:00:00:00:00"
+
+static void delete_wireless_content(char *boot_part)
+{
+	if(!boot_part)
+	{
+		return;
+	}
+
+
+	block_dev_desc_t *fs_dev_desc;
+	disk_partition_t fs_partition;
+
+	int part = get_device_and_partition("mmc", boot_part, &fs_dev_desc,
+					&fs_partition, 1);
+
+	if(!part)
+	{
+		return;
+	}
+
+	if(ext4fs_probe(fs_dev_desc, &fs_partition)){
+		printf("\n** Unable to use %s %s for loading the env **\n",
+			   "mmc", boot_part);
+		return;
+	}
+
+	ext4_remove_file(WIRELESS_FILE);
+	ext4fs_close();
+}
+
+// this function should be remove in production
+static void temporary_gen_mac(char *boot_part, char *output)
+{
+	if(!boot_part)
+	{
+		return;
+	}
+
+	ALLOC_CACHE_ALIGN_BUFFER(char, buff, 255);
+
+	block_dev_desc_t *fs_dev_desc;
+	disk_partition_t fs_partition;
+
+	int part = get_device_and_partition("mmc", boot_part, &fs_dev_desc,
+					&fs_partition, 1);
+
+	if(!part)
+	{
+		return;
+	}
+
+	if(ext4fs_probe(fs_dev_desc, &fs_partition)){
+		printf("\n** Unable to use %s %s for loading the env **\n",
+			   "mmc", boot_part);
+		return;
+	}
+
+	int err;
+	loff_t off;
+	// loff_t write;
+	err = ext4_read_file(SECURITY_CONFIG_FILE, buff, 0, 255, &off);
+
+	if (err == -1) {
+		printf("\n** Unable to read \"%s\" from %s%s **\n",
+			SECURITY_CONFIG_FILE, "mmc", boot_part);
+		return;
+	}
+
+	ext4fs_close();
+
+	char last3bytes[8];
+	char *first_minute = NULL;
+	char *next_minute = NULL;
+	char *deviceid_pointer = strstr(buff, "deviceid");
+	if(deviceid_pointer)
+	{
+		first_minute = strchr(deviceid_pointer, '\'');// find '
+	}
+
+	if(first_minute)
+	{
+		next_minute = strchr(first_minute+1, '\'');// find '
+	}
+	
+	if(next_minute)
+	{
+		/*remove 2 '' and 8 first byte*/
+		size_t length = next_minute-first_minute -1 -8;
+		if(length > (sizeof(last3bytes)-1))
+		{
+			return;
+		}
+
+		strncpy(last3bytes, first_minute+1+8, length);
+		last3bytes[length] = '\0';
+
+		char byte1[3],byte2[3],byte3[3];
+		strncpy(byte3, last3bytes, 2);
+		byte3[2]='\0';
+
+		strncpy(byte2, last3bytes+2, 2);
+		byte2[2]='\0';
+
+		strncpy(byte1, last3bytes+4, 2);
+		byte1[2]='\0';
+
+		sprintf(output, "aa:bb:cc:%s:%s:%s", byte3, byte2, byte1);
+	}
+}
+
+static int detect_boot_part(void)
+{
+	int bootstate = getenv_ulong("bootstate", 10, 0);
+	int checkboot = getenv_ulong("checkboot", 10, 0);
+
+	printf("bootstate %d\n", bootstate);
+	printf("checkboot %d\n", checkboot);
+
+	switch(bootstate) {
+		case 0:
+			return 2;
+
+		case 1:
+			if(checkboot)
+				return 3;
+			else
+				return 2;
+
+		case 2:
+			return 3;
+
+		case 3:
+			if(checkboot)
+				return 2;
+			else
+				return 3;
+		
+		default:
+			return 2;
+	}
+}
+
+static void write_epprom_macaddress(char *macAddress)
+{
+	struct am335x_baseboard_id header;
+	struct zinno_product_info proinfo;
+
+	/* Check if baseboard eeprom is available */
+	if (i2c_probe(CONFIG_SYS_I2C_EEPROM_ADDR)) {
+		puts("Could not probe the EEPROM; something fundamentally "
+			"wrong on the I2C bus.\n");
+		return;
+	}
+
+	/* read the eeprom using i2c */
+	if (i2c_read(CONFIG_SYS_I2C_EEPROM_ADDR, CONFIG_SYS_EEPROM_PRODUCT_INFO, 2, (uchar *)&header,
+			 sizeof(struct am335x_baseboard_id))
+		) 
+	{
+		puts("Could not read the EEPROM; something fundamentally"
+			" wrong on the I2C bus.\n");
+		return;
+	}
+
+	if (i2c_read(CONFIG_SYS_I2C_EEPROM_ADDR, CONFIG_SYS_EEPROM_PRODUCT_INFO+ header.offset_content, 2, (uchar *)&proinfo, 
+				sizeof(struct zinno_product_info))
+		)
+	{
+		puts("Could not read the EEPROM; something fundamentally"
+			" wrong on the I2C bus.\n");
+		return;
+	}
+
+	printf("current wifi  %s\n", proinfo.wifi_mac_address);
+	printf("crc current wifi  %02X\n", proinfo.wifi_mac_address[32]);
+
+	memcpy(proinfo.wifi_mac_address, macAddress, HDR_NAME_SIZE_32);
+	proinfo.wifi_mac_address[HDR_NAME_SIZE_32]=crc8((unsigned char *)proinfo.wifi_mac_address, HDR_NAME_SIZE_32);
+
+	printf("new wifi  %s\n", (char*)proinfo.wifi_mac_address);
+	printf("crc wifi %02X\n", proinfo.wifi_mac_address[32]);
+
+	header.crc32_content = crc32(0, (unsigned char *)&proinfo, sizeof(struct zinno_product_info));
+	header.hdr_crc8 = crc8((unsigned char *)&header, sizeof(struct am335x_baseboard_id) - 1);
+
+	printf("new crc32_content  %X\n", header.crc32_content);
+	printf("new hdr_crc8  %02X\n", header.hdr_crc8);
+
+
+	uint8_t *test = (uint8_t*)&proinfo;
+	int i;
+	for(i = 0; i < sizeof(struct zinno_product_info); i++)
+	{
+		printf("%02X ", test[i]);
+		if(i > 0 && ((i%16)==0))
+		{
+			printf("\n");
+		}
+	}
+
+	uint8_t *test1 = (uint8_t*)&header;
+	for(i = 0; i < sizeof(struct am335x_baseboard_id); i++)
+	{
+		printf("%02X ", test1[i]);
+		if(i > 0 && ((i%16)==0))
+		{
+			printf("\n");
+		}
+	}
+
+	if(!gpio_request(100, "Write_protect"))
+	{
+		if(!gpio_direction_output(100, 0))
+		{
+			/* Write header */
+			write_data_eeprom(CONFIG_SYS_EEPROM_PRODUCT_INFO, 
+							(uint8_t *)&header, sizeof(struct am335x_baseboard_id));
+
+			mdelay(1000);
+
+			/* Write data info */
+			write_data_eeprom(CONFIG_SYS_EEPROM_PRODUCT_INFO + DATA_CONTENT_OFFSET, 
+							(uint8_t *)&proinfo, sizeof(struct zinno_product_info));
+		}
+		gpio_free(100);
+	}
+}
+
+static void change_wifi_firmware_info(char *wifi_mac_address)
+{
+	if(!wifi_mac_address)
+	{
+		return;
+	}
+
+	ALLOC_CACHE_ALIGN_BUFFER(char, buff, 12);
+	ALLOC_CACHE_ALIGN_BUFFER(char, boot_part, 4);
+	ALLOC_CACHE_ALIGN_BUFFER(char, current_mac, 32);
+
+	snprintf(boot_part, 4, "1:%d", detect_boot_part());
+
+	printf("boot_part = %s\n", boot_part);
+
+	block_dev_desc_t *fs_dev_desc;
+	disk_partition_t fs_partition;
+
+	int part = get_device_and_partition("mmc", boot_part, &fs_dev_desc,
+					&fs_partition, 1);
+
+	if(!part)
+	{
+		return;
+	}
+
+	// if(!fs_dev_desc);
+	//     return;
+
+	if(ext4fs_probe(fs_dev_desc, &fs_partition)){
+		printf("\n** Unable to use %s %s for loading the env **\n",
+			   "mmc", boot_part);
+		return;
+	}
+	
+	int err;
+	loff_t off;
+	loff_t write;
+	err = ext4_read_file(FIRMWARE_FILE, buff, 0, 12, &off);
+
+	if (err == -1) {
+		printf("\n** Unable to read \"%s\" from %s%s **\n",
+			FIRMWARE_FILE, "mmc", boot_part);
+		return;
+	}
+
+	ext4fs_close();
+
+	snprintf(current_mac, 32, "%02x:%02x:%02x:%02x:%02x:%02x",
+			buff[11], buff[10], buff[6], buff[5], buff[4],
+			buff[3]);
+
+	printf("current_mac %s\n", current_mac);
+	printf("wifi_mac_address %s\n", wifi_mac_address);
+
+	if(!strcmp(wifi_mac_address, DEFAULT_MAC))
+	{
+		if(!strcmp(current_mac, DEFAULT_MAC))
+		{
+			temporary_gen_mac(OVERLAY_PART, wifi_mac_address);
+			write_epprom_macaddress(wifi_mac_address);
+			ext4fs_probe(fs_dev_desc, &fs_partition);
+		}
+		else
+		{
+			write_epprom_macaddress(current_mac);
+			return;
+		}
+	}
+
+	if(!strcmp(current_mac, wifi_mac_address))
+	{
+		return;
+	}
+
+	printf("update wifi mac from: %s to %s\n",
+			current_mac, wifi_mac_address);
+	ALLOC_CACHE_ALIGN_BUFFER(int, in_mac, 6);
+
+	err = sscanf(wifi_mac_address, "%2x:%2x:%2x:%2x:%2x:%2x",
+		&in_mac[0], &in_mac[1], &in_mac[2],
+		&in_mac[3], &in_mac[4], &in_mac[5]);
+	if (err != 6) {
+		fprintf(stderr, "MAC address is not valid: %s\n", wifi_mac_address);
+		return;
+	}
+
+	buff[11] = (unsigned char)in_mac[0];
+	buff[10] = (unsigned char)in_mac[1];
+	buff[6]  = (unsigned char)in_mac[2];
+	buff[5]  = (unsigned char)in_mac[3];
+	buff[4]  = (unsigned char)in_mac[4];
+	buff[3]  = (unsigned char)in_mac[5];
+
+	ext4_write_file(FIRMWARE_FILE, buff, 0, off, &write);
+	ext4fs_close();
+	delete_wireless_content(OVERLAY_PART);
+}
 
 int board_late_init(void)
 {
@@ -556,6 +898,8 @@
 	if (read_eeprom(&header, &proinfo) < 0)
 		puts("Could not get board ID.\n");
 
+	printf("BOARD NAME:%s\n", (char *)proinfo.product_name);
+	printf("REVISION:%s\n", (char *)proinfo.main_revision);
 	int board_name = CERES_BOARD;
 	board_name = get_board_name(&proinfo);
 
@@ -570,9 +914,6 @@
 
 	setenv("bootdelay", "1");
 
-	printf("BOARD NAME:%s\n", (char *)proinfo.product_name);
-	printf("REVISION:%s\n", (char *)proinfo.main_revision);
-
 	strncpy(safe_string, (char *)proinfo.company_name, HDR_NAME_SIZE_32);
 	safe_string[HDR_NAME_SIZE_32] = 0;
 	setenv("vendor", safe_string);
@@ -585,6 +926,7 @@
 	safe_string[HDR_NAME_SIZE_16] = 0;
 	setenv("board_rev", safe_string);
 
+	change_wifi_firmware_info(proinfo.wifi_mac_address);
 	strncpy(safe_string, (char *)proinfo.wifi_mac_address, HDR_NAME_SIZE_32);
 	safe_string[HDR_NAME_SIZE_32] = 0;
 	setenv("wifi_mac_address", safe_string);
@@ -596,6 +938,7 @@
 	strncpy(safe_string, (char *)proinfo.serial_number, HDR_NAME_SIZE_16);
 	safe_string[HDR_NAME_SIZE_16] = 0;
 	setenv("serial_number", safe_string);	
+	saveenv();
 
 #endif
 
--- a/include/configs/venus.h	2018-06-24 14:37:06.211055142 +0700
+++ b/include/configs/venus.h	2018-06-23 19:00:30.000000000 +0700
@@ -485,5 +485,6 @@
 #define CONFIG_LEDS
 #define CONFIG_CMD_LEDS_LP5523
 #define CONFIG_LEDS_LP5523
+#define CONFIG_CMD_EXT4_WRITE
 
 #endif	/* ! __CONFIG_VENUS_H */
--- a/board/verik/titan/board.c	2018-06-24 14:43:00.000000000 +0700
+++ b/board/verik/titan/board.c	2018-06-24 14:51:20.343039846 +0700
@@ -31,8 +31,9 @@
 #include <power/tps65910.h>
 #include <environment.h>
 #include <watchdog.h>
-#include <environment.h>
 #include <leds.h>
+#include <u-boot/crc.h>
+#include <ext4fs.h>
 #include "board.h"
 
 DECLARE_GLOBAL_DATA_PTR;
@@ -123,6 +124,7 @@
 				printf("write eeprom section :%d failure.\n", i);
 				return 0;
 			}	
+			mdelay(100);
 		}
 
 		if(remainder)
@@ -175,6 +177,7 @@
 				/* Write header */
 				write_data_eeprom(CONFIG_SYS_EEPROM_PRODUCT_INFO, (uint8_t *)buffer_header, sizeof(buffer_header));
 
+				mdelay(1000);
 				/* Write data info */
 				write_data_eeprom(offset_data, (uint8_t *)buffer_data, sizeof(buffer_data));
 			}
@@ -197,11 +200,11 @@
 	return 1;
 };
 
-static int read_data(unsigned int offset_content, struct zinno_product_info *proinfo, uint32_t check_sum)
+static int read_data(struct am335x_baseboard_id *header, struct zinno_product_info *proinfo)
 {
 	uint32_t val = 0;
 	unsigned int offset_data = 0;
-	offset_data = CONFIG_SYS_EEPROM_PRODUCT_INFO + offset_content;
+	offset_data = CONFIG_SYS_EEPROM_PRODUCT_INFO + header->offset_content;
 	
 	/* Check if baseboard eeprom is available */
 	if (i2c_probe(CONFIG_SYS_I2C_EEPROM_ADDR)) {
@@ -220,7 +223,7 @@
 	val = crc32(0, (unsigned char *)proinfo, sizeof(struct zinno_product_info));
 
 	/* Check Contents crc32 */
-	if(check_sum != val) 
+	if(header->crc32_content != val) 
 	{
 		printf("EEPROM Product data CRC32 wrong.\n");			
 		
@@ -229,6 +232,8 @@
 		{
 			if(!gpio_direction_output(100, 0))
 			{
+				write_data_eeprom(CONFIG_SYS_EEPROM_PRODUCT_INFO, (uint8_t *)buffer_header, sizeof(buffer_header));
+				mdelay(1000);
 				write_data_eeprom(offset_data, (uint8_t *)buffer_data, sizeof(buffer_data));
 			}
 
@@ -236,6 +241,13 @@
 		}
 		mdelay(1000);
 
+		if (i2c_read(CONFIG_SYS_I2C_EEPROM_ADDR, CONFIG_SYS_EEPROM_PRODUCT_INFO, 2, (uchar *)header,
+			 sizeof(struct am335x_baseboard_id))) 
+		{
+			puts("Could not read the EEPROM; something fundamentally"
+				" wrong on the I2C bus.\n");
+			return 0;
+		}
 		if (i2c_read(CONFIG_SYS_I2C_EEPROM_ADDR, offset_data, 2, (uchar *)proinfo, sizeof(struct zinno_product_info))) 
 		{
 			puts("Could not read the EEPROM; something fundamentally"
@@ -269,7 +281,7 @@
 	/* Check magic header*/
 	if(board_is_zinno(header)) 
 	{
-		if(read_data((unsigned int)header->offset_content, proinfo, header->crc32_content))
+		if(read_data(header, proinfo))
 		{
 			printf("Read Data EEPROM Success.\n");
 		}	
@@ -544,6 +556,337 @@
 	{-1},
 };
 #endif
+#define FIRMWARE_FILE           "/lib/firmware/ti-connectivity/wl1271-nvs.bin" 
+#define WIRELESS_FILE           "/etc/config/wireless"
+#define SECURITY_CONFIG_FILE    "/etc/config/security"
+#define OVERLAY_PART            "1:5"
+#define DEFAULT_MAC             "00:00:00:00:00:00"
+
+static void delete_wireless_content(char *boot_part)
+{
+	if(!boot_part)
+	{
+		return;
+	}
+
+
+	block_dev_desc_t *fs_dev_desc;
+	disk_partition_t fs_partition;
+
+	int part = get_device_and_partition("mmc", boot_part, &fs_dev_desc,
+					&fs_partition, 1);
+
+	if(!part)
+	{
+		return;
+	}
+
+	if(ext4fs_probe(fs_dev_desc, &fs_partition)){
+		printf("\n** Unable to use %s %s for loading the env **\n",
+			   "mmc", boot_part);
+		return;
+	}
+
+	ext4_remove_file(WIRELESS_FILE);
+	ext4fs_close();
+}
+
+// this function should be remove in production
+static void temporary_gen_mac(char *boot_part, char *output)
+{
+	if(!boot_part)
+	{
+		return;
+	}
+
+	ALLOC_CACHE_ALIGN_BUFFER(char, buff, 255);
+
+	block_dev_desc_t *fs_dev_desc;
+	disk_partition_t fs_partition;
+
+	int part = get_device_and_partition("mmc", boot_part, &fs_dev_desc,
+					&fs_partition, 1);
+
+	if(!part)
+	{
+		return;
+	}
+
+	if(ext4fs_probe(fs_dev_desc, &fs_partition)){
+		printf("\n** Unable to use %s %s for loading the env **\n",
+			   "mmc", boot_part);
+		return;
+	}
+
+	int err;
+	loff_t off;
+	// loff_t write;
+	err = ext4_read_file(SECURITY_CONFIG_FILE, buff, 0, 255, &off);
+
+	if (err == -1) {
+		printf("\n** Unable to read \"%s\" from %s%s **\n",
+			SECURITY_CONFIG_FILE, "mmc", boot_part);
+		return;
+	}
+
+	ext4fs_close();
+
+	char last3bytes[8];
+	char *first_minute = NULL;
+	char *next_minute = NULL;
+	char *deviceid_pointer = strstr(buff, "deviceid");
+	if(deviceid_pointer)
+	{
+		first_minute = strchr(deviceid_pointer, '\'');// find '
+	}
+
+	if(first_minute)
+	{
+		next_minute = strchr(first_minute+1, '\'');// find '
+	}
+	
+	if(next_minute)
+	{
+		/*remove 2 '' and 8 first byte*/
+		size_t length = next_minute-first_minute -1 -8;
+		if(length > (sizeof(last3bytes)-1))
+		{
+			return;
+		}
+
+		strncpy(last3bytes, first_minute+1+8, length);
+		last3bytes[length] = '\0';
+
+		char byte1[3],byte2[3],byte3[3];
+		strncpy(byte3, last3bytes, 2);
+		byte3[2]='\0';
+
+		strncpy(byte2, last3bytes+2, 2);
+		byte2[2]='\0';
+
+		strncpy(byte1, last3bytes+4, 2);
+		byte1[2]='\0';
+
+		sprintf(output, "aa:bb:cc:%s:%s:%s", byte3, byte2, byte1);
+	}
+}
+
+static int detect_boot_part(void)
+{
+	int bootstate = getenv_ulong("bootstate", 10, 0);
+	int checkboot = getenv_ulong("checkboot", 10, 0);
+
+	printf("bootstate %d\n", bootstate);
+	printf("checkboot %d\n", checkboot);
+
+	switch(bootstate) {
+		case 0:
+			return 2;
+
+		case 1:
+			if(checkboot)
+				return 3;
+			else
+				return 2;
+
+		case 2:
+			return 3;
+
+		case 3:
+			if(checkboot)
+				return 2;
+			else
+				return 3;
+		
+		default:
+			return 2;
+	}
+}
+
+static void write_epprom_macaddress(char *macAddress)
+{
+	struct am335x_baseboard_id header;
+	struct zinno_product_info proinfo;
+
+	/* Check if baseboard eeprom is available */
+	if (i2c_probe(CONFIG_SYS_I2C_EEPROM_ADDR)) {
+		puts("Could not probe the EEPROM; something fundamentally "
+			"wrong on the I2C bus.\n");
+		return;
+	}
+
+	/* read the eeprom using i2c */
+	if (i2c_read(CONFIG_SYS_I2C_EEPROM_ADDR, CONFIG_SYS_EEPROM_PRODUCT_INFO, 2, (uchar *)&header,
+			 sizeof(struct am335x_baseboard_id))
+		) 
+	{
+		puts("Could not read the EEPROM; something fundamentally"
+			" wrong on the I2C bus.\n");
+		return;
+	}
+
+	if (i2c_read(CONFIG_SYS_I2C_EEPROM_ADDR, CONFIG_SYS_EEPROM_PRODUCT_INFO+ header.offset_content, 2, (uchar *)&proinfo, 
+				sizeof(struct zinno_product_info))
+		)
+	{
+		puts("Could not read the EEPROM; something fundamentally"
+			" wrong on the I2C bus.\n");
+		return;
+	}
+
+	printf("current wifi  %s\n", proinfo.wifi_mac_address);
+	printf("crc current wifi  %02X\n", proinfo.wifi_mac_address[32]);
+
+	memcpy(proinfo.wifi_mac_address, macAddress, HDR_NAME_SIZE_32);
+	proinfo.wifi_mac_address[HDR_NAME_SIZE_32]=crc8((unsigned char *)proinfo.wifi_mac_address, HDR_NAME_SIZE_32);
+
+	printf("new wifi  %s\n", (char*)proinfo.wifi_mac_address);
+	printf("crc wifi %02X\n", proinfo.wifi_mac_address[32]);
+
+	header.crc32_content = crc32(0, (unsigned char *)&proinfo, sizeof(struct zinno_product_info));
+	header.hdr_crc8 = crc8((unsigned char *)&header, sizeof(struct am335x_baseboard_id) - 1);
+
+	printf("new crc32_content  %X\n", header.crc32_content);
+	printf("new hdr_crc8  %02X\n", header.hdr_crc8);
+
+
+	uint8_t *test = (uint8_t*)&proinfo;
+	int i;
+	for(i = 0; i < sizeof(struct zinno_product_info); i++)
+	{
+		printf("%02X ", test[i]);
+		if(i > 0 && ((i%16)==0))
+		{
+			printf("\n");
+		}
+	}
+
+	uint8_t *test1 = (uint8_t*)&header;
+	for(i = 0; i < sizeof(struct am335x_baseboard_id); i++)
+	{
+		printf("%02X ", test1[i]);
+		if(i > 0 && ((i%16)==0))
+		{
+			printf("\n");
+		}
+	}
+
+	if(!gpio_request(100, "Write_protect"))
+	{
+		if(!gpio_direction_output(100, 0))
+		{
+			/* Write header */
+			write_data_eeprom(CONFIG_SYS_EEPROM_PRODUCT_INFO, 
+							(uint8_t *)&header, sizeof(struct am335x_baseboard_id));
+
+			mdelay(1000);
+
+			/* Write data info */
+			write_data_eeprom(CONFIG_SYS_EEPROM_PRODUCT_INFO + DATA_CONTENT_OFFSET, 
+							(uint8_t *)&proinfo, sizeof(struct zinno_product_info));
+		}
+		gpio_free(100);
+	}
+}
+
+static void change_wifi_firmware_info(char *wifi_mac_address)
+{
+	if(!wifi_mac_address)
+	{
+		return;
+	}
+
+	ALLOC_CACHE_ALIGN_BUFFER(char, buff, 12);
+	ALLOC_CACHE_ALIGN_BUFFER(char, boot_part, 4);
+	ALLOC_CACHE_ALIGN_BUFFER(char, current_mac, 32);
+
+	snprintf(boot_part, 4, "1:%d", detect_boot_part());
+
+	printf("boot_part = %s\n", boot_part);
+
+	block_dev_desc_t *fs_dev_desc;
+	disk_partition_t fs_partition;
+
+	int part = get_device_and_partition("mmc", boot_part, &fs_dev_desc,
+					&fs_partition, 1);
+
+	if(!part)
+	{
+		return;
+	}
+
+	// if(!fs_dev_desc);
+	//     return;
+
+	if(ext4fs_probe(fs_dev_desc, &fs_partition)){
+		printf("\n** Unable to use %s %s for loading the env **\n",
+			   "mmc", boot_part);
+		return;
+	}
+	
+	int err;
+	loff_t off;
+	loff_t write;
+	err = ext4_read_file(FIRMWARE_FILE, buff, 0, 12, &off);
+
+	if (err == -1) {
+		printf("\n** Unable to read \"%s\" from %s%s **\n",
+			FIRMWARE_FILE, "mmc", boot_part);
+		return;
+	}
+
+	ext4fs_close();
+
+	snprintf(current_mac, 32, "%02x:%02x:%02x:%02x:%02x:%02x",
+			buff[11], buff[10], buff[6], buff[5], buff[4],
+			buff[3]);
+
+	printf("current_mac %s\n", current_mac);
+	printf("wifi_mac_address %s\n", wifi_mac_address);
+
+	if(!strcmp(wifi_mac_address, DEFAULT_MAC))
+	{
+		if(!strcmp(current_mac, DEFAULT_MAC))
+		{
+			temporary_gen_mac(OVERLAY_PART, wifi_mac_address);
+			write_epprom_macaddress(wifi_mac_address);
+			ext4fs_probe(fs_dev_desc, &fs_partition);
+		}
+		else
+		{
+			write_epprom_macaddress(current_mac);
+			return;
+		}
+	}
+
+	if(!strcmp(current_mac, wifi_mac_address))
+	{
+		return;
+	}
+
+	printf("update wifi mac from: %s to %s\n",
+			current_mac, wifi_mac_address);
+	ALLOC_CACHE_ALIGN_BUFFER(int, in_mac, 6);
+
+	err = sscanf(wifi_mac_address, "%2x:%2x:%2x:%2x:%2x:%2x",
+		&in_mac[0], &in_mac[1], &in_mac[2],
+		&in_mac[3], &in_mac[4], &in_mac[5]);
+	if (err != 6) {
+		fprintf(stderr, "MAC address is not valid: %s\n", wifi_mac_address);
+		return;
+	}
+
+	buff[11] = (unsigned char)in_mac[0];
+	buff[10] = (unsigned char)in_mac[1];
+	buff[6]  = (unsigned char)in_mac[2];
+	buff[5]  = (unsigned char)in_mac[3];
+	buff[4]  = (unsigned char)in_mac[4];
+	buff[3]  = (unsigned char)in_mac[5];
+
+	ext4_write_file(FIRMWARE_FILE, buff, 0, off, &write);
+	ext4fs_close();
+	delete_wireless_content(OVERLAY_PART);
+}
 
 int board_late_init(void)
 {
@@ -584,6 +926,7 @@
 	safe_string[HDR_NAME_SIZE_16] = 0;
 	setenv("board_rev", safe_string);
 
+	change_wifi_firmware_info(proinfo.wifi_mac_address);
 	strncpy(safe_string, (char *)proinfo.wifi_mac_address, HDR_NAME_SIZE_32);
 	safe_string[HDR_NAME_SIZE_32] = 0;
 	setenv("wifi_mac_address", safe_string);
@@ -595,6 +938,7 @@
 	strncpy(safe_string, (char *)proinfo.serial_number, HDR_NAME_SIZE_16);
 	safe_string[HDR_NAME_SIZE_16] = 0;
 	setenv("serial_number", safe_string);	
+	saveenv();
 
 #endif
 
--- a/include/configs/titan.h	2018-06-24 14:43:00.000000000 +0700
+++ b/include/configs/titan.h	2018-06-24 14:49:10.531042171 +0700
@@ -486,5 +486,6 @@
 #define CONFIG_LEDS
 #define CONFIG_CMD_LEDS_LP5523
 #define CONFIG_LEDS_LP5523
+#define CONFIG_CMD_EXT4_WRITE
 
 #endif	/* ! __CONFIG_TITAN_H */
